/*
File	: testLEDs.pde
Version	: 1.0
Date	: 14.01.2015
Project	: myMatrix Arduino Library

The MIT License (MIT)

Copyright (c) 2015 Silviu - www.openhardware.ro

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

/*
  The circuit:
  A   connect to digital pin 2
  B   connect to digital pin 3
  C   connect to digital pin 4
  D   connect to digital pin 5
  OE  connect to digital pin 6
  R   connect to digital pin 7
  G   connect to digital pin 8
  CLK connect to digital pin 9
  STB connect to digital pin 10
  GND connect to GND
  
  This sketch will turn on all LEDs red and green
  uses only standard Arduino functions (without myMatrix library)
  use for panel testing 
  pins can be changed at will
*/

#define RowA 2 
#define RowB 3 
#define RowC 4 
#define RowD 5 

#define OE 6 
#define R 7 
#define G 8 
#define CLK 9 
#define STB 10 

void setup () 
{
     pinMode(RowA, OUTPUT);
     pinMode(RowB, OUTPUT);
     pinMode(RowC, OUTPUT);
     pinMode(RowD, OUTPUT);
     pinMode(OE, OUTPUT);
     pinMode(R, OUTPUT);
     pinMode(G, OUTPUT);
     pinMode(CLK, OUTPUT);
     pinMode(STB, OUTPUT);     
}    

void loop()
{
  for(byte row=0;row<16;row++)
  {
    digitalWrite(OE,HIGH); // screen off
    
    for (int i = 0; i<31; i++) 
    {
      digitalWrite(R,LOW);  // LOW=> All RED ON , HIGH=> All RED OFF
      digitalWrite(G,LOW); // LOW=> All GREEN ON , HIGH=> All GREEN OFF
      
      //Clock Pulse
      digitalWrite(CLK, HIGH);
      digitalWrite(CLK, LOW);        
    }
    
    rowScan(row);
    digitalWrite(STB,LOW);
    digitalWrite(STB,HIGH);
    
    digitalWrite(OE,LOW); // screen on
    delayMicroseconds(500);
    //delay(50);
  }
}

void rowScan(byte r){
  digitalWrite(RowA,(r & 0x01));
  digitalWrite(RowB,(r & 0x02));
  digitalWrite(RowC,(r & 0x04));
  digitalWrite(RowD,(r & 0x08));
}  

 


 
